/*
 * Copyright (C) 2013 Peng fei Pan <sky@xiaopan.me>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.cg.baseproject.constant;

/**
 * 常用符号
 */
public class Symbols {
	/**
	 * 冒号
	 */
	public static final char COLON = ':';
	
	/**
	 * 冒号 - 中文
	 */
	public static final char COLON_CHINESE = '：';
	
	/**
	 * 分号
	 */
	public static final char SEMICOLON = ';';
	
	/**
	 * 分号 - 中文
	 */
	public static final char SEMICOLON_CHINESE = '；';
	
	/**
	 * 逗号
	 */
	public static final char COMMA = ',';
	
	/**
	 * 逗号 - 中文
	 */
	public static final char COMMA_CHINESE = '，';
	
	/**
	 * 引号
	 */
	public static final char QUOTES = '"';
	
	/**
	 * 引号 - 中文 - 左
	 */
	public static final char QUOTES_CHINESE_LEFT = '“';
	
	/**
	 * 引号 - 中文 - 右
	 */
	public static final char QUOTES_CHINESE_RIGHT = '”';
	
	/**
	 * 问号
	 */
	public static final char QUESTION_MARK = '?';
	
	/**
	 * 问号 - 中文
	 */
	public static final char QUESTION_MARK_CHINESE = '？';
	
	/**
	 * 尖括号 - 左
	 */
	public static final char ANGLE_BRACKETS_LEFT = '<';
	
	/**
	 * 尖括号 - 中文 - 左
	 */
	public static final char ANGLE_BRACKETS_CHINESE_LEFT = '《';
	
	/**
	 * 尖括号 - 右
	 */
	public static final char ANGLE_BRACKETS_RIGHT  = '>';
	
	/**
	 * 尖括号 - 中文 - 右
	 */
	public static final char ANGLE_BRACKETS_CHINESE_RIGHT  = '》';
	
	/**
	 * 小括号 - 左
	 */
	public static final char PARENTHESES_LEFT = '(';
	
	/**
	 * 小括号 - 中文 - 左
	 */
	public static final char PARENTHESES_CHINESE_LEFT = '（';
	
	/**
	 * 小括号 - 右
	 */
	public static final char PARENTHESES_RIGHT  = ')';
	
	/**
	 * 小括号 - 中文 - 右
	 */
	public static final char PARENTHESES_CHINESE_RIGHT  = '）';
	
	/**
	 * 大括号 - 左
	 */
	public static final char CURLY_BRACES_LEFT = '{';
	
	/**
	 * 大括号 - 右
	 */
	public static final char CURLY_BRACES_RIGHT  = '}';
}